## libpod 3.2.1+ds1

=== Makefile ===
###
### Makefile Navigation
###
#
# This file is organized based on approximate end-to-end workflow:
#
# 1.  Variables and common definitions are located at the top
#     to make finding them quicker.
# 2.  Main entry-point targets, like "default", "all", and "help"
# 3.  Targets for code formatting and validation
# 4.  Primary build targets, like podman and podman-remote
# 5.  Secondary build targets, shell completions, static and multi-arch.
# 6.  Targets that format and build documentation
# 7.  Testing targets
# 8.  Release and package-building targets
# 9.  Targets that install tools, utilities, binaries and packages
# 10. Uninstall / Cleanup targets
#
###
### Variables & Definitions
###

export GOPROXY=https://proxy.golang.org

GO ?= go
COVERAGE_PATH ?= .coverage
DESTDIR ?=
EPOCH_TEST_COMMIT ?= $(shell git merge-base $${DEST_BRANCH:-master} HEAD)
HEAD ?= HEAD
CHANGELOG_BASE ?= HEAD~
CHANGELOG_TARGET ?= HEAD
PROJECT := github.com/containers/podman
GIT_BASE_BRANCH ?= origin/master
GIT_BRANCH ?= $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
GIT_BRANCH_CLEAN ?= $(shell echo $(GIT_BRANCH) | sed -e "s/[^[:alnum:]]/-/g")
LIBPOD_INSTANCE := libpod_dev
PREFIX ?= /usr/local
BINDIR ?= ${PREFIX}/bin
LIBEXECDIR ?= ${PREFIX}/libexec
MANDIR ?= ${PREFIX}/share/man
SHAREDIR_CONTAINERS ?= ${PREFIX}/share/containers
ETCDIR ?= /etc
TMPFILESDIR ?= ${PREFIX}/lib/tmpfiles.d
SYSTEMDDIR ?= ${PREFIX}/lib/systemd/system
USERSYSTEMDDIR ?= ${PREFIX}/lib/systemd/user
REMOTETAGS ?= remote exclude_graphdriver_btrfs btrfs_noversion exclude_graphdriver_devicemapper containers_image_openpgp
BUILDTAGS ?= \
	$(shell hack/apparmor_tag.sh) \
	$(shell hack/btrfs_installed_tag.sh) \
	$(shell hack/btrfs_tag.sh) \
	$(shell hack/selinux_tag.sh) \
	$(shell hack/systemd_tag.sh) \
	exclude_graphdriver_devicemapper \
	seccomp
PYTHON ?= $(shell command -v python3 python|head -n1)
PKG_MANAGER ?= $(shell command -v dnf yum|head -n1)
# ~/.local/bin is not in PATH on all systems
PRE_COMMIT = $(shell command -v bin/venv/bin/pre-commit ~/.local/bin/pre-commit pre-commit | head -n1)

# This isn't what we actually build; it's a superset, used for target
# dependencies. Basically: all *.go files, except *_test.go, and except
# anything in a dot subdirectory. If any of these files is newer than
# our target (bin/podman{,-remote}), a rebuild is triggered.
SOURCES = $(shell find . -path './.*' -prune -o \( -name '*.go' -a ! -name '*_test.go' \) -print)

BUILDFLAGS := -mod=vendor $(BUILDFLAGS)

BUILDTAGS_CROSS ?= containers_image_openpgp exclude_graphdriver_btrfs exclude_graphdriver_devicemapper exclude_graphdriver_overlay
CONTAINER_RUNTIME := $(shell command -v podman 2> /dev/null || echo docker)
OCI_RUNTIME ?= ""

MANPAGES_MD ?= $(wildcard docs/source/markdown/*.md pkg/*/docs/*.md)
MANPAGES ?= $(MANPAGES_MD:%.md=%)
MANPAGES_DEST ?= $(subst markdown,man, $(subst source,build,$(MANPAGES)))

BASHINSTALLDIR=${PREFIX}/share/bash-completion/completions
ZSHINSTALLDIR=${PREFIX}/share/zsh/site-functions
FISHINSTALLDIR=${PREFIX}/share/fish/vendor_completions.d

SELINUXOPT ?= $(shell test -x /usr/sbin/selinuxenabled && selinuxenabled && echo -Z)

COMMIT_NO ?= $(shell git rev-parse HEAD 2> /dev/null || true)
GIT_COMMIT ?= $(if $(shell git status --porcelain --untracked-files=no),${COMMIT_NO}-dirty,${COMMIT_NO})
DATE_FMT = %s
ifdef SOURCE_DATE_EPOCH
	BUILD_INFO ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u "+$(DATE_FMT)")
	ISODATE ?= $(shell date -d "@$(SOURCE_DATE_EPOCH)" --iso-8601)
else
	BUILD_INFO ?= $(shell date "+$(DATE_FMT)")
	ISODATE ?= $(shell date --iso-8601)
endif
LIBPOD := ${PROJECT}/v3/libpod
GCFLAGS ?= all=-trimpath=$(CURDIR)
ASMFLAGS ?= all=-trimpath=$(CURDIR)
LDFLAGS_PODMAN ?= \
	  -X $(LIBPOD)/define.gitCommit=$(GIT_COMMIT) \
	  -X $(LIBPOD)/define.buildInfo=$(BUILD_INFO) \
	  -X $(LIBPOD)/config._installPrefix=$(PREFIX) \
	  -X $(LIBPOD)/config._etcDir=$(ETCDIR) \
	  $(EXTRA_LDFLAGS)
#Update to LIBSECCOMP_COMMIT should reflect in Dockerfile too.
LIBSECCOMP_COMMIT := v2.3.3
# Rarely if ever should integration tests take more than 50min,
# caller may override in special circumstances if needed.
GINKGOTIMEOUT ?= -timeout=90m

RELEASE_VERSION ?= $(shell hack/get_release_info.sh VERSION)
RELEASE_NUMBER ?= $(shell hack/get_release_info.sh NUMBER|sed -e 's/^v\(.*\)/\1/')
RELEASE_DIST ?= $(shell hack/get_release_info.sh DIST)
RELEASE_DIST_VER ?= $(shell hack/get_release_info.sh DIST_VER)
RELEASE_ARCH ?= $(shell hack/get_release_info.sh ARCH)
RELEASE_BASENAME := $(shell hack/get_release_info.sh BASENAME)

# If non-empty, logs all output from server during remote system testing
PODMAN_SERVER_LOG ?=

# If GOPATH not specified, use one in the local directory
ifeq ($(GOPATH),)
export GOPATH := $(HOME)/go
unexport GOBIN
endif
FIRST_GOPATH := $(firstword $(subst :, ,$(GOPATH)))
GOPKGDIR := $(FIRST_GOPATH)/src/$(PROJECT)
GOPKGBASEDIR ?= $(shell dirname "$(GOPKGDIR)")

GOBIN := $(shell $(GO) env GOBIN)
ifeq ($(GOBIN),)
GOBIN := $(FIRST_GOPATH)/bin
endif

export PATH := $(PATH):$(GOBIN)

GOMD2MAN ?= $(shell command -v go-md2man || echo '$(GOBIN)/go-md2man')

CROSS_BUILD_TARGETS := \
	bin/podman.cross.linux.amd64 \
	bin/podman.cross.linux.ppc64le \
	bin/podman.cross.linux.arm \
	bin/podman.cross.linux.arm64 \
	bin/podman.cross.linux.386 \
	bin/podman.cross.linux.s390x \
	bin/podman.cross.linux.mips \
	bin/podman.cross.linux.mipsle \
	bin/podman.cross.linux.mips64 \
	bin/podman.cross.linux.mips64le

# Dereference variable $(1), return value if non-empty, otherwise raise an error.
err_if_empty = $(if $(strip $($(1))),$(strip $($(1))),$(error Required variable $(1) value is undefined, whitespace, or empty))

# Podman does not work w/o CGO_ENABLED, except in some very specific cases
CGO_ENABLED ?= 1
# Default to the native OS type and architecture unless otherwise specified
GOOS ?= $(shell $(GO) env GOOS)
ifeq ($(call err_if_empty,GOOS),windows)
BINSFX := .exe
SRCBINDIR := bin/windows
else ifeq ($(GOOS),darwin)
BINSFX :=
SRCBINDIR := bin/darwin
else
BINSFX := -remote
SRCBINDIR := bin
endif
# Necessary for nested-$(MAKE) calls and docs/remote-docs.sh
export GOOS CGO_ENABLED BINSFX SRCBINDIR

define go-get
	env GO111MODULE=off \
		$(GO) get -u ${1}
endef

###
### Primary entry-point targets
###

.PHONY: default
default: all

.PHONY: all
all: binaries docs

.PHONY: binaries
binaries: podman podman-remote ## Build podman and podman-remote binaries

# Extract text following double-# for targets, as their description for
# the `help` target.  Otherwise These simple-substitutions are resolved
# at reference-time (due to `=` and not `=:`).
_HLP_TGTS_RX = '^[[:print:]]+:.*?\#\# .*$$'
_HLP_TGTS_CMD = grep -E $(_HLP_TGTS_RX) $(MAKEFILE_LIST)
_HLP_TGTS_LEN = $(shell $(_HLP_TGTS_CMD) | cut -d : -f 1 | wc -L)
_HLPFMT = "%-$(_HLP_TGTS_LEN)s %s\n"
.PHONY: help
help: ## (Default) Print listing of key targets with their descriptions
	@printf $(_HLPFMT) "Target:" "Description:"
	@printf $(_HLPFMT) "--------------" "--------------------"
	@$(_HLP_TGTS_CMD) | sort | \
		awk 'BEGIN {FS = ":(.*)?## "}; \
			{printf $(_HLPFMT), $$1, $$2}'

###
### Linting/Formatting/Code Validation targets
###

.gopathok:
ifeq ("$(wildcard $(GOPKGDIR))","")
	mkdir -p "$(GOPKGBASEDIR)"
	ln -sfn "$(CURDIR)" "$(GOPKGDIR)"
endif
	touch $@

.PHONY: .gitvalidation
.gitvalidation: .gopathok
	@echo "Validating vs commit '$(call err_if_empty,EPOCH_TEST_COMMIT)'"
	GIT_CHECK_EXCLUDE="./vendor:docs/make.bat" $(GOBIN)/git-validation -run DCO,short-subject,dangling-whitespace -range $(EPOCH_TEST_COMMIT)..$(HEAD)

.PHONY: lint
lint: golangci-lint
	@echo "Linting vs commit '$(call err_if_empty,EPOCH_TEST_COMMIT)'"
ifeq ($(PRE_COMMIT),)
	@echo "FATAL: pre-commit was not found, make .install.pre-commit to installing it." >&2
	@exit 2
endif
	$(PRE_COMMIT) run -a

.PHONY: golangci-lint
golangci-lint: .gopathok .install.golangci-lint
	hack/golangci-lint.sh run

.PHONY: gofmt
gofmt: ## Verify the source code gofmt
	find . -name '*.go' -type f \
		-not \( \
			-name '.golangci.yml' -o \
			-name 'Makefile' -o \
			-path './vendor/*' -prune -o \
			-path './contrib/*' -prune \
		\) -exec gofmt -d -e -s -w {} \+
	git diff --exit-code

.PHONY: test/checkseccomp/checkseccomp
test/checkseccomp/checkseccomp: .gopathok $(wildcard test/checkseccomp/*.go)
	$(GO) build $(BUILDFLAGS) -ldflags '$(LDFLAGS_PODMAN)' -tags "$(BUILDTAGS)" -o $@ ./test/checkseccomp

.PHONY: test/testvol/testvol
test/testvol/testvol: .gopathok $(wildcard test/testvol/*.go)
	$(GO) build $(BUILDFLAGS) -ldflags '$(LDFLAGS_PODMAN)' -o $@ ./test/testvol

.PHONY: volume-plugin-test-image
volume-plugin-test-img:
	podman build -t quay.io/libpod/volume-plugin-test-img -f Containerfile-testvol .

.PHONY: test/goecho/goecho
test/goecho/goecho: .gopathok $(wildcard test/goecho/*.go)
	$(GO) build $(BUILDFLAGS) -ldflags '$(LDFLAGS_PODMAN)' -o $@ ./test/goecho

.PHONY: codespell
codespell:
	codespell -S bin,vendor,.git,go.sum,changelog.txt,.cirrus.yml,"RELEASE_NOTES.md,*.xz,*.gz,*.tar,*.tgz,bin2img,*ico,*.png,*.1,*.5,copyimg,*.orig,apidoc.go" -L uint,iff,od,seeked,splitted,marge,ERRO,hist,ether -w

.PHONY: validate
validate: gofmt lint .gitvalidation validate.completions man-page-check swagger-check tests-included

.PHONY: build-all-new-commits
build-all-new-commits:
	# Validate that all the commits build on top of $(GIT_BASE_BRANCH)
	git rebase $(GIT_BASE_BRANCH) -x make

.PHONY: vendor
vendor:
	GO111MODULE=on $(GO) mod tidy
	GO111MODULE=on $(GO) mod vendor
	GO111MODULE=on $(GO) mod verify

.PHONY: vendor-in-container
vendor-in-container:
	podman run --privileged --rm --env HOME=/root \
		-v $(CURDIR):/src -w /src \
		docker.io/library/golang:1.16 \
		make vendor

###
### Primary binary-build targets
###

# Make sure to warn in case we're building without the systemd buildtag.
bin/podman: .gopathok $(SOURCES) go.mod go.sum
ifeq (,$(findstring systemd,$(BUILDTAGS)))
	@echo "Podman is being compiled without the systemd build tag. \
		Install libsystemd on Ubuntu or systemd-devel on rpm based \
		distro for journald support."
endif
	CGO_ENABLED=$(CGO_ENABLED) \
		$(GO) build \
		$(BUILDFLAGS) \
		-gcflags '$(GCFLAGS)' \
		-asmflags '$(ASMFLAGS)' \
		-ldflags '$(LDFLAGS_PODMAN)' \
		-tags "$(BUILDTAGS)" \
		-o $@ ./cmd/podman

# Disambiguate Linux vs Darwin/Windows platform binaries under distinct "bin" dirs
$(SRCBINDIR):
	mkdir -p $(SRCBINDIR)

$(SRCBINDIR)/podman$(BINSFX): $(SRCBINDIR) .gopathok $(SOURCES) go.mod go.sum
	CGO_ENABLED=$(CGO_ENABLED) \
		GOOS=$(GOOS) \
		$(GO) build \
		$(BUILDFLAGS) \
		-gcflags '$(GCFLAGS)' \
		-asmflags '$(ASMFLAGS)' \
		-ldflags '$(LDFLAGS_PODMAN)' \
		-tags "${REMOTETAGS}" \
		-o $@ ./cmd/podman

$(SRCBINDIR)/podman-remote-static: $(SRCBINDIR) .gopathok $(SOURCES) go.mod go.sum
	CGO_ENABLED=$(CGO_ENABLED) \
		GOOS=$(GOOS) \
		$(GO) build \
		$(BUILDFLAGS) \
		-gcflags '$(GCFLAGS)' \
		-asmflags '$(ASMFLAGS)' \
		-ldflags '$(LDFLAGS_PODMAN_STATIC)' \
		-tags "${REMOTETAGS}" \
		-o $@ ./cmd/podman

.PHONY: podman
podman: bin/podman

.PHONY: podman-remote
podman-remote: $(SRCBINDIR) $(SRCBINDIR)/podman$(BINSFX)  ## Build podman-remote binary

# A wildcard podman-remote-% target incorrectly sets GOOS for release targets
.PHONY: podman-remote-linux
podman-remote-linux: ## Build podman-remote for Linux
	$(MAKE) \
		CGO_ENABLED=0 \
		GOOS=linux \
		bin/podman-remote

PHONY: podman-remote-static
podman-remote-static: $(SRCBINDIR)/podman-remote-static

.PHONY: podman-remote-windows
podman-remote-windows: ## Build podman-remote for Windows
	$(MAKE) \
		CGO_ENABLED=0 \
		GOOS=windows \
		bin/windows/podman.exe

.PHONY: podman-remote-darwin
podman-remote-darwin: ## Build podman-remote for macOS
	$(MAKE) \
		CGO_ENABLED=0 \
		GOOS=darwin \
		bin/darwin/podman

###
### Secondary binary-build targets
###

.PHONY: generate-bindings
generate-bindings:
ifneq ($(GOOS),darwin)
	GO111MODULE=off $(GO) generate ./pkg/bindings/... ;

=== debian/changelog ===
libpod (3.2.1+ds1-2ubuntu3) impish; urgency=medium

  * Rebuild against newer containers-common to fix seccomp issue, LP: #1943049

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 22 Sep 2021 14:40:40 -0400

libpod (3.2.1+ds1-2ubuntu2) impish; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - docker.io package in ubuntu installs some sources into different
      locations, work around that in debian/rules
    - don't build binary package golang-github-containers-libpod-dev,
      because some docker packages are vendored differently, that
      package fails in autopkgtest and cannot posibly work.
  * Fixup confused merge with debian

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 15 Jun 2021 14:12:41 -0400

libpod (3.2.1+ds1-2) experimental; urgency=medium

  * Provide 'podman-docker' package, Closes: #984770
  * Tighten build dependency on golang-golang-x-net-dev

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 15 Jun 2021 13:41:46 -0400

libpod (3.2.1+ds1-1) experimental; urgency=medium

  * New upstream release
  * Tighten build-depends on golang-github-containers-common-dev
    and golang-github-containers-buildah-dev

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 14 Jun 2021 14:08:01 -0400

libpod (3.2.0+ds5-2ubuntu1) impish; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - docker.io package in ubuntu installs some sources into different
      locations, work around that in debian/rules
    - don't build binary package golang-github-containers-libpod-dev,
      because some docker packages are vendored differently, that
      package fails in autopkgtest and cannot posibly work.
  * Tighten build-dendency on buildah

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 12 Jun 2021 17:13:55 -0400

libpod (3.2.0+ds5-2) experimental; urgency=medium

  * Add patch from upstream to fix FTBFS on !(arm64, amd64)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 12 Jun 2021 07:07:45 -0400

libpod (3.2.0+ds5-1) experimental; urgency=medium

  * New upstream release
  * Install zsh completions (Closes: #989411)
  * Disable LTO, cf. https://wiki.debian.org/ToolChain/LTO

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 08 Jun 2021 17:33:43 -0400

libpod (3.1.2+ds1-2ubuntu1) impish; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - docker.io package in ubuntu installs some sources into different
      locations, work around that in debian/rules
    - don't build binary package golang-github-containers-libpod-dev,
      because some docker packages are vendored differently, that
      package fails in autopkgtest and cannot posibly work.

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 30 May 2021 18:16:23 -0400

libpod (3.1.2+ds1-2) experimental; urgency=medium

  * add missing vendored files included in tarball
  * (explicitly) build-depend on golang-github-moby-term-dev

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 31 May 2021 09:55:52 -0400

libpod (3.1.2+ds1-1) experimental; urgency=medium

  * New upstream release
  * Drop dependency on golang-github-seccomp-containers-golang-dev,
    Closes: #988445

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 28 May 2021 17:57:28 -0400

libpod (3.1.0+ds1-1) experimental; urgency=medium

  * New upstream release
  * Reorganized git source layout. Drop a number of vendored libraries
    (in favor of versions from the Debian archive)
    - github.com/go-logr/logr
    - github.com/moby/term
    - github.com/nxadm/tail
    - github.com/willf/bitset
    - go.etcd.io/bbolt
    - google.golang.org/protobuf

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 03 Apr 2021 16:28:54 -0400

libpod (3.0.1+dfsg1-1ubuntu1) hirsute; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - docker.io package in ubuntu installs some sources into different
      locations, work around that in debian/rules

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 26 Feb 2021 17:11:36 -0500

=== debian/control ===
Source: libpod
Section: admin
Priority: optional
Standards-Version: 4.5.0
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>, Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper-compat (= 13)
    ,bash-completion
    ,conmon
    ,dh-golang
    ,go-md2man
    ,golang-any
    ,golang-dbus-dev (>= 5.0.2~)
    ,golang-ginkgo-dev
    ,golang-github-appc-cni-dev (>= 0.8)
    ,golang-github-buger-goterm-dev
    ,golang-github-checkpoint-restore-go-criu-dev
    ,golang-github-containerd-cgroups-dev
    ,golang-github-containernetworking-plugins-dev (>= 0.8.7)
    ,golang-github-containers-buildah-dev (>= 1.21.0)
    ,golang-github-containers-common-dev (>= 0.38.16+ds1-1ubuntu1)
    ,golang-github-containers-image-dev (>= 5.10.5)
    ,golang-github-containers-ocicrypt-dev
    ,golang-github-containers-psgo-dev
    ,golang-github-containers-storage-dev (>= 1.28)
    ,golang-github-coreos-bbolt-dev (>= 1.3.3~)
    ,golang-github-coreos-go-iptables-dev (>= 0.4.2~)
    ,golang-github-coreos-go-systemd-dev (>= 20~)
    ,golang-github-cyphar-filepath-securejoin-dev (>= 0.2.2~)
    ,golang-github-docker-distribution-dev (>= 2.7.1~)
    ,golang-github-docker-docker-dev (>= 20.10.0~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-spdystream-dev
    ,golang-github-fullsailor-pkcs7-dev
    ,golang-github-ghodss-yaml-dev
    ,golang-github-go-logr-logr-dev
    ,golang-github-google-shlex-dev
    ,golang-github-google-uuid-dev
    ,golang-github-hashicorp-go-multierror-dev
    ,golang-github-influxdata-tail-dev (>= 1.0.0+git20180327.c434825-2~) | golang-github-hpcloud-tail-dev
    ,golang-github-json-iterator-go-dev
    ,golang-github-moby-term-dev
    ,golang-github-mrunalp-fileutils-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc92~)
    ,golang-github-opencontainers-runtime-tools-dev (>= 0.9.0~)
    ,golang-github-opencontainers-selinux-dev (>= 1.2.2~)
    ,golang-github-opencontainers-specs-dev (>= 1.0.2.41.g7413a7f-1ubuntu1)
    ,golang-github-openshift-api-dev
    ,golang-github-openshift-imagebuilder-dev
    ,golang-github-pkg-errors-dev
    ,golang-github-pkg-profile-dev
    ,golang-github-rootless-containers-rootlesskit-dev
    ,golang-github-seccomp-libseccomp-golang-dev
    ,golang-github-sirupsen-logrus-dev
    ,golang-github-stretchr-testify-dev
    ,golang-github-uber-go-atomic-dev
    ,golang-github-ulikunitz-xz-dev
    ,golang-github-vbatts-tar-split-dev
    ,golang-github-vbauerster-mpb-dev (>= 6)
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0+git20181030~)
    ,golang-github-vividcortex-ewma-dev
    ,golang-go-zfs-dev
    ,golang-go.opencensus-dev
    ,golang-golang-x-crypto-dev
    ,golang-golang-x-net-dev (>= 1:0.0+git20210119)
    ,golang-golang-x-sys-dev
    ,golang-golang-x-text-dev
    ,golang-golang-x-tools
    ,golang-golang-x-xerrors-dev
    ,golang-gomega-dev
    ,golang-google-genproto-dev
    ,golang-google-grpc-dev
    ,golang-gopkg-inf.v0-dev
    ,golang-gopkg-square-go-jose.v2-dev
    ,golang-gopkg-yaml.v3-dev
    ,golang-k8s-sigs-structured-merge-diff-dev (>> 4)
    ,golang-k8s-sigs-yaml-dev
    ,golang-toml-dev
    ,libapparmor-dev
    ,libbtrfs-dev
    ,libdevmapper-dev
    ,libglib2.0-dev
    ,libostree-dev
# sphinx docs:
#   ,python3-recommonmark
Homepage: https://github.com/containers/podman
Vcs-Browser: https://salsa.debian.org/debian/libpod
Vcs-Git: https://salsa.debian.org/debian/libpod.git
XS-Go-Import-Path: github.com/containers/podman
Testsuite: autopkgtest-pkg-go

Package: podman
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}
    ,conmon (>= 2.0.18~)
    ,containernetworking-plugins (>= 0.8.7)
    ,golang-github-containers-common
    ,runc (>= 1.0.0~rc92~) | crun
Breaks: buildah (<< 1.10.1-6), slirp4netns (<< 0.4.1), fuse-overlayfs (<< 0.7.1)
Recommends: ${misc:Recommends}
    ,buildah (>= 1.21.0)
    ,fuse-overlayfs (>= 1.0.0~)
    ,slirp4netns (>= 0.4.1~)
    ,catatonit | tini | dumb-init
    ,uidmap
    ,golang-github-containernetworking-plugin-dnsname
Suggests: ${misc:Suggests}
    ,containers-storage
    ,docker-compose
Description: engine to run OCI-based containers in Pods
 Podman is an engine for running OCI-based containers in Pods.
 Podman provides a CLI interface for managing Pods, Containers, and
 Container Images.
 .
 At a high level, the scope of libpod and podman is the following:
  * Support multiple image formats including the OCI and Docker image
    formats.
  * Support for multiple means to download images including trust & image
    verification.
  * Container image management (managing image layers, overlay filesystems,
    etc).
  * Full management of container lifecycle.
  * Support for pods to manage groups of containers together.
  * Resource isolation of containers and pods.
  * Support for a Docker-compatible CLI interface through Podman.
 .
 Podman is a daemon-less alternative to Docker.

Package: podman-docker
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, podman
Conflicts: docker.io
Recommends: docker-compose
Description: engine to run OCI-based containers in Pods - wrapper for docker
 Podman is an engine for running OCI-based containers in Pods.
 Podman provides a CLI interface for managing Pods, Containers, and
 Container Images.
 .
 At a high level, the scope of libpod and podman is the following:
  * Support multiple image formats including the OCI and Docker image
    formats.
  * Support for multiple means to download images including trust & image
    verification.
  * Container image management (managing image layers, overlay filesystems,
    etc).
  * Full management of container lifecycle.
  * Support for pods to manage groups of containers together.
  * Resource isolation of containers and pods.
  * Support for a Docker-compatible CLI interface through Podman.
 .
 Podman is a daemon-less alternative to Docker.
 .
 This package installs a wrapper script that acts like the original docker
 implementation

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

# cf. https://wiki.debian.org/ToolChain/LTO and https://github.com/golang/go/issues/45275
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

export GO111MODULE=off

export DH_GOLANG_GO_GENERATE := 1

export DH_GOLANG_INSTALL_EXTRA := $(wildcard libpod/*/testdata/*)
export DH_GOLANG_EXCLUDES := dependencies test/e2e contrib/perftest test/utils test/endpoint hack/podman-registry-go pkg/bindings/test

export HOME=$(CURDIR)/debian/tmp

## https://podman.io/getting-started/installation#build-tags
BUILDTAGS := apparmor,ostree,seccomp,selinux,systemd
# containers_image_openpgp

%:
	dh $@ --buildsystem=golang --with=golang,bash-completion --builddirectory=_output

override_dh_auto_configure:
	# force debhelper to symlink subdirs in docker, enables workarounds below
	mkdir -v -p _output/src/github.com/docker/docker/vendor/github.com/docker/go-connections/
	dh_auto_configure
	# workaround some vendoring issues - in ubuntu all docker vendored libraries
	# are installed in the "vendor/" subdirectory
	test -d _output/src/github.com/docker/libnetwork || \
	  ln -sv docker/vendor/github.com/docker/libnetwork \
	     _output/src/github.com/docker

	# Golang insanity
	# workaround "sub-vendored" package github.com/docker/go-connections/nat
	rm -rf _output/src/github.com/docker/docker/vendor/github.com/docker/go-connections/

override_dh_auto_build:
	$(MAKE) docs docker-docs

#	LDFLAGS_PODMAN="-X main.gitCommit=$(GIT_COMMIT)"
	dh_auto_build -v  --builddirectory=_output -- -tags "$(BUILDTAGS)" \
          -ldflags "-X main.buildInfo=$(DEB_VERSION)"

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# make test binaries available where the tests expect them
	ln -sv  ../../../../bin  _output/src/github.com/containers/podman/bin
	mkdir -p -m700 $(CURDIR)/debian/tmp-home/.cache
	mkdir -p -m700 $(CURDIR)/debian/tmp-home/.config
	mkdir -p -m700 $(CURDIR)/debian/tmp-home/.local/share
	mkdir -p -m700 $(CURDIR)/debian/tmp-home/run
	env \
	  HOME=$(CURDIR)/debian/tmp-home/.cache \
	  XDG_CACHE_HOME=$(CURDIR)/debian/tmp-home/.cache \
	  XDG_CONFIG_HOME=$(CURDIR)/debian/tmp-home/.config \
	  XDG_DATA_HOME=$(CURDIR)/debian/tmp-home/.local/share \
	  XDG_RUNTIME_DIR=$(CURDIR)/debian/tmp-home/run \
	  PATH="$(CURDIR)/_output/bin:$$PATH" \
	  DH_GOLANG_EXCLUDES="$${DH_GOLANG_EXCLUDES} libpod/lock/file libpod/hack/podman-registry-go libpod/pkg/bindings/test podman/cmd/podman/common" \
	dh_auto_test -v --max-parallel=2 -- -tags "$(BUILDTAGS)"
	rm -rf $(CURDIR)/debian/tmp-home
endif

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp --buildsystem=golang --builddirectory=_output
	# avoid exposing unnecessary vendor libraries
	rm -rfv debian/tmp/usr/share/gocode/src/github.com/containers/libpod/vendor

# Disable dh_missing
override_dh_missing:

override_dh_installsystemd:
	dh_installsystemd
	dh_installsystemd --name=podman-auto-update

## libpod 3.4.4+ds1

=== Makefile ===
--- 
+++ 
@@ -25,12 +25,12 @@
 GO ?= go
 COVERAGE_PATH ?= .coverage
 DESTDIR ?=
-EPOCH_TEST_COMMIT ?= $(shell git merge-base $${DEST_BRANCH:-master} HEAD)
+EPOCH_TEST_COMMIT ?= $(shell git merge-base $${DEST_BRANCH:-main} HEAD)
 HEAD ?= HEAD
 CHANGELOG_BASE ?= HEAD~
 CHANGELOG_TARGET ?= HEAD
 PROJECT := github.com/containers/podman
-GIT_BASE_BRANCH ?= origin/master
+GIT_BASE_BRANCH ?= origin/main
 GIT_BRANCH ?= $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
 GIT_BRANCH_CLEAN ?= $(shell echo $(GIT_BRANCH) | sed -e "s/[^[:alnum:]]/-/g")
 LIBPOD_INSTANCE := libpod_dev
@@ -39,7 +39,7 @@
 LIBEXECDIR ?= ${PREFIX}/libexec
 MANDIR ?= ${PREFIX}/share/man
 SHAREDIR_CONTAINERS ?= ${PREFIX}/share/containers
-ETCDIR ?= /etc
+ETCDIR ?= ${PREFIX}/etc
 TMPFILESDIR ?= ${PREFIX}/lib/tmpfiles.d
 SYSTEMDDIR ?= ${PREFIX}/lib/systemd/system
 USERSYSTEMDDIR ?= ${PREFIX}/lib/systemd/user
@@ -50,6 +50,7 @@
 	$(shell hack/btrfs_tag.sh) \
 	$(shell hack/selinux_tag.sh) \
 	$(shell hack/systemd_tag.sh) \
+	$(shell hack/libsubid_tag.sh) \
 	exclude_graphdriver_devicemapper \
 	seccomp
 PYTHON ?= $(shell command -v python3 python|head -n1)
@@ -58,10 +59,11 @@
 PRE_COMMIT = $(shell command -v bin/venv/bin/pre-commit ~/.local/bin/pre-commit pre-commit | head -n1)
 
 # This isn't what we actually build; it's a superset, used for target
-# dependencies. Basically: all *.go files, except *_test.go, and except
-# anything in a dot subdirectory. If any of these files is newer than
-# our target (bin/podman{,-remote}), a rebuild is triggered.
-SOURCES = $(shell find . -path './.*' -prune -o \( -name '*.go' -a ! -name '*_test.go' \) -print)
+# dependencies. Basically: all *.go and *.c files, except *_test.go,
+# and except anything in a dot subdirectory. If any of these files is
+# newer than our target (bin/podman{,-remote}), a rebuild is
+# triggered.
+SOURCES = $(shell find . -path './.*' -prune -o \( \( -name '*.go' -o -name '*.c' \) -a ! -name '*_test.go' \) -print)
 
 BUILDFLAGS := -mod=vendor $(BUILDFLAGS)
 
@@ -90,14 +92,16 @@
 	ISODATE ?= $(shell date --iso-8601)
 endif
 LIBPOD := ${PROJECT}/v3/libpod
-GCFLAGS ?= all=-trimpath=$(CURDIR)
-ASMFLAGS ?= all=-trimpath=$(CURDIR)
+GOFLAGS ?= -trimpath
 LDFLAGS_PODMAN ?= \
-	  -X $(LIBPOD)/define.gitCommit=$(GIT_COMMIT) \
-	  -X $(LIBPOD)/define.buildInfo=$(BUILD_INFO) \
-	  -X $(LIBPOD)/config._installPrefix=$(PREFIX) \
-	  -X $(LIBPOD)/config._etcDir=$(ETCDIR) \
-	  $(EXTRA_LDFLAGS)
+	-X $(LIBPOD)/define.gitCommit=$(GIT_COMMIT) \
+	-X $(LIBPOD)/define.buildInfo=$(BUILD_INFO) \
+	-X $(LIBPOD)/config._installPrefix=$(PREFIX) \
+	-X $(LIBPOD)/config._etcDir=$(ETCDIR) \
+	$(EXTRA_LDFLAGS)
+LDFLAGS_PODMAN_STATIC ?= \
+	$(LDFLAGS_PODMAN) \
+	-extldflags=-static
 #Update to LIBSECCOMP_COMMIT should reflect in Dockerfile too.
 LIBSECCOMP_COMMIT := v2.3.3
 # Rarely if ever should integration tests take more than 50min,
@@ -168,6 +172,15 @@
 	env GO111MODULE=off \
 		$(GO) get -u ${1}
 endef
+
+# Need to use CGO for mDNS resolution, but cross builds need CGO disabled
+# See https://github.com/golang/go/issues/12524 for details
+DARWIN_GCO := 0
+ifeq ($(NATIVE_GOOS),darwin)
+ifdef HOMEBREW_PREFIX
+	DARWIN_GCO := 1
+endif
+endif
 
 ###
 ### Primary entry-point targets
@@ -211,7 +224,7 @@
 .PHONY: .gitvalidation
 .gitvalidation: .gopathok
 	@echo "Validating vs commit '$(call err_if_empty,EPOCH_TEST_COMMIT)'"
-	GIT_CHECK_EXCLUDE="./vendor:docs/make.bat" $(GOBIN)/git-validation -run DCO,short-subject,dangling-whitespace -range $(EPOCH_TEST_COMMIT)..$(HEAD)
+	GIT_CHECK_EXCLUDE="./vendor:docs/make.bat:test/buildah-bud/buildah-tests.diff" $(GOBIN)/git-validation -run DCO,short-subject,dangling-whitespace -range $(EPOCH_TEST_COMMIT)..$(HEAD)
 
 .PHONY: lint
 lint: golangci-lint
@@ -255,10 +268,10 @@
 
 .PHONY: codespell
 codespell:
-	codespell -S bin,vendor,.git,go.sum,changelog.txt,.cirrus.yml,"RELEASE_NOTES.md,*.xz,*.gz,*.tar,*.tgz,bin2img,*ico,*.png,*.1,*.5,copyimg,*.orig,apidoc.go" -L uint,iff,od,seeked,splitted,marge,ERRO,hist,ether -w
+	codespell -S bin,vendor,.git,go.sum,.cirrus.yml,"RELEASE_NOTES.md,*.xz,*.gz,*.ps1,*.tar,*.tgz,bin2img,*ico,*.png,*.1,*.5,copyimg,*.orig,apidoc.go" -L uint,iff,od,seeked,splitted,marge,ERRO,hist,ether -w
 
 .PHONY: validate
-validate: gofmt lint .gitvalidation validate.completions man-page-check swagger-check tests-included
+validate: gofmt lint .gitvalidation validate.completions man-page-check swagger-check tests-included tests-expect-exit
 
 .PHONY: build-all-new-commits
 build-all-new-commits:
@@ -292,8 +305,6 @@
 	CGO_ENABLED=$(CGO_ENABLED) \
 		$(GO) build \
 		$(BUILDFLAGS) \
-		-gcflags '$(GCFLAGS)' \
-		-asmflags '$(ASMFLAGS)' \
 		-ldflags '$(LDFLAGS_PODMAN)' \
 		-tags "$(BUILDTAGS)" \
 		-o $@ ./cmd/podman
@@ -307,19 +318,15 @@
 		GOOS=$(GOOS) \
 		$(GO) build \
 		$(BUILDFLAGS) \
-		-gcflags '$(GCFLAGS)' \
-		-asmflags '$(ASMFLAGS)' \
 		-ldflags '$(LDFLAGS_PODMAN)' \
 		-tags "${REMOTETAGS}" \
 		-o $@ ./cmd/podman
 
 $(SRCBINDIR)/podman-remote-static: $(SRCBINDIR) .gopathok $(SOURCES) go.mod go.sum
-	CGO_ENABLED=$(CGO_ENABLED) \
+	CGO_ENABLED=0 \
 		GOOS=$(GOOS) \
 		$(GO) build \
 		$(BUILDFLAGS) \
-		-gcflags '$(GCFLAGS)' \
-		-asmflags '$(ASMFLAGS)' \
 		-ldflags '$(LDFLAGS_PODMAN_STATIC)' \
 		-tags "${REMOTETAGS}" \
 		-o $@ ./cmd/podman
@@ -351,15 +358,4 @@
 .PHONY: podman-remote-darwin
 podman-remote-darwin: ## Build podman-remote for macOS
 	$(MAKE) \
-		CGO_ENABLED=0 \
-		GOOS=darwin \
-		bin/darwin/podman
-
-###
-### Secondary binary-build targets
-###
-
-.PHONY: generate-bindings
-generate-bindings:
-ifneq ($(GOOS),darwin)
-	GO111MODULE=off $(GO) generate ./pkg/bindings/... ;
+		CGO_ENABLED=$(DARWIN_GCO) \

=== debian/changelog ===
libpod (3.4.4+ds1-1ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - docker.io package in ubuntu installs some sources into different
      locations, work around that in debian/rules

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 23 Jan 2022 14:04:53 -0500

libpod (3.4.4+ds1-1) unstable; urgency=medium

  * New upstream release
    Confirming that CVE-2021-4024 is fixed in 3.4.3, Closes: #1000844

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 25 Dec 2021 19:48:14 -0500

libpod (3.4.3+ds1-1) unstable; urgency=medium

  * New upstream release, Closes: #1001321
    - podman machine spawns gvproxy with port binded to all IPs,
      Closes: #1000844

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 24 Dec 2021 14:40:01 -0500

libpod (3.4.2+ds1-1) unstable; urgency=medium

  * New upstream release
  * Compile against system github.com/dtylman/scp
  * Revert upstream commit that requires newer godbus than we currently
    have in unstable

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 17 Nov 2021 14:30:31 -0500

libpod (3.4.1+ds1-2) unstable; urgency=medium

  * Upload to unstable
  * podman: Install tmpfiles.d/podman.conf, Closes: #995586

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 26 Oct 2021 18:20:56 -0400

libpod (3.4.1+ds1-1) experimental; urgency=medium

  * New upstream release

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 25 Oct 2021 13:58:58 -0400

libpod (3.4.0+ds1-1) experimental; urgency=medium

  * New upstream release

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 08 Oct 2021 16:19:40 -0400

libpod (3.3.1+ds2-1) unstable; urgency=medium

  * New upstream release
    - drop coreos/{go-iptables,go-systemd}
  * Drop unneeded dependency on golang-github-openshift-api-dev
  * Bump Standards-Version, no changes needed

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 07 Sep 2021 11:53:40 +0200

libpod (3.3.0+ds2-2) unstable; urgency=medium

  * Apply missing patches that were forgotten in the last merge
    from experimental:
    - Prefer crun over runc
    - Add depends in iptables
  * Upstream improved documentation on requirements for rootless,
    Closes: #983395

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 04 Sep 2021 18:57:31 +0200

libpod (3.3.0+ds2-1) unstable; urgency=medium

  * New upstream release, Closes: #992138, #992142

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 30 Aug 2021 12:37:34 +0200

libpod (3.2.3+ds1-1) experimental; urgency=medium

  * New upstream releases, Closes: #991197
  * Bump dependency on golang-github-containers-common,buildah

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 20 Jul 2021 18:22:50 -0400

libpod (3.2.2+ds1-1) experimental; urgency=medium

  * New upstream releases, Closes: #990333
  * Bump dependency on golang-github-containers-common

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 28 Jun 2021 08:15:51 -0400

libpod (3.0.0+dfsg1-2ubuntu4) hirsute; urgency=medium

  * Tighten dependency on golang-golang-x-net (>> 1:0.0+git20210119)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 21 Feb 2021 08:27:28 -0500

libpod (3.0.0+dfsg1-2ubuntu2) hirsute; urgency=medium

  * Avoid building golang-github-containers-libpod-dev
    - Because docker.io vendors golang modules differently,
      this package is not usable on ubuntu anyways.

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 20 Feb 2021 11:52:11 -0500

libpod (3.0.0+dfsg1-2ubuntu1) hirsute; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - docker.io package in ubuntu installs some sources into different
      locations, work around that in debian/rules

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 17 Feb 2021 20:26:23 -0500

libpod (2.1.1+dfsg1-4ubuntu1) hirsute; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - docker.io package in ubuntu installs some sources into different
      locations, work around that in debian/rules

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 21 Jan 2021 11:03:01 -0500

libpod (2.0.6+dfsg1-2ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - docker.io package in ubuntu installs some sources into different
      locations, work around that in debian/rules
    - allow building with older runc

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 30 Nov 2020 12:57:54 -0800

libpod (2.0.6+dfsg1-1ubuntu2) hirsute; urgency=medium

  * No-change rebuild using new golang

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 11 Nov 2020 22:19:18 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: libpod
 Section: admin
 Priority: optional
-Standards-Version: 4.5.0
-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
+Standards-Version: 4.6.0
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@debian.org>, Reinhard Tartler <siretart@tauware.de>
 Build-Depends: debhelper-compat (= 13)
     ,bash-completion
@@ -14,15 +15,15 @@
     ,golang-ginkgo-dev
     ,golang-github-appc-cni-dev (>= 0.8)
     ,golang-github-buger-goterm-dev
-    ,golang-github-checkpoint-restore-go-criu-dev
+    ,golang-github-checkpoint-restore-go-criu-dev (>> 5.1)
     ,golang-github-containerd-cgroups-dev
     ,golang-github-containernetworking-plugins-dev (>= 0.8.7)
-    ,golang-github-containers-buildah-dev (>= 1.21.0)
-    ,golang-github-containers-common-dev (>= 0.38.16+ds1-1ubuntu1)
-    ,golang-github-containers-image-dev (>= 5.10.5)
+    ,golang-github-containers-buildah-dev (>= 1.23.1)
+    ,golang-github-containers-common-dev (>= 0.44.4)
+    ,golang-github-containers-image-dev (>= 5.16)
     ,golang-github-containers-ocicrypt-dev
     ,golang-github-containers-psgo-dev
-    ,golang-github-containers-storage-dev (>= 1.28)
+    ,golang-github-containers-storage-dev (>= 1.36)
     ,golang-github-coreos-bbolt-dev (>= 1.3.3~)
     ,golang-github-coreos-go-iptables-dev (>= 0.4.2~)
     ,golang-github-coreos-go-systemd-dev (>= 20~)
@@ -32,6 +33,7 @@
     ,golang-github-docker-go-connections-dev (>= 0.4.0~)
     ,golang-github-docker-go-units-dev (>= 0.4.0~)
     ,golang-github-docker-spdystream-dev
+    ,golang-github-dtylman-scp-dev
     ,golang-github-fullsailor-pkcs7-dev
     ,golang-github-ghodss-yaml-dev
     ,golang-github-go-logr-logr-dev
@@ -44,11 +46,9 @@
     ,golang-github-mrunalp-fileutils-dev
     ,golang-github-opencontainers-go-digest-dev
     ,golang-github-opencontainers-image-spec-dev
-    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc92~)
+    ,golang-github-opencontainers-runc-dev
     ,golang-github-opencontainers-runtime-tools-dev (>= 0.9.0~)
     ,golang-github-opencontainers-selinux-dev (>= 1.2.2~)
-    ,golang-github-opencontainers-specs-dev (>= 1.0.2.41.g7413a7f-1ubuntu1)
-    ,golang-github-openshift-api-dev
     ,golang-github-openshift-imagebuilder-dev
     ,golang-github-pkg-errors-dev
     ,golang-github-pkg-profile-dev
@@ -76,10 +76,12 @@
     ,golang-gopkg-inf.v0-dev
     ,golang-gopkg-square-go-jose.v2-dev
     ,golang-gopkg-yaml.v3-dev
+    ,golang-k8s-klog-dev
     ,golang-k8s-sigs-structured-merge-diff-dev (>> 4)
     ,golang-k8s-sigs-yaml-dev
     ,golang-toml-dev
     ,libapparmor-dev
+    ,libseccomp-dev
     ,libbtrfs-dev
     ,libdevmapper-dev
     ,libglib2.0-dev
@@ -99,7 +101,7 @@
     ,conmon (>= 2.0.18~)
     ,containernetworking-plugins (>= 0.8.7)
     ,golang-github-containers-common
-    ,runc (>= 1.0.0~rc92~) | crun
+    ,crun | runc (>= 1.0.0~rc92~)
 Breaks: buildah (<< 1.10.1-6), slirp4netns (<< 0.4.1), fuse-overlayfs (<< 0.7.1)
 Recommends: ${misc:Recommends}
     ,buildah (>= 1.21.0)
@@ -111,6 +113,7 @@
 Suggests: ${misc:Suggests}
     ,containers-storage
     ,docker-compose
+    ,iptables
 Description: engine to run OCI-based containers in Pods
  Podman is an engine for running OCI-based containers in Pods.
  Podman provides a CLI interface for managing Pods, Containers, and
@@ -130,8 +133,96 @@
  .
  Podman is a daemon-less alternative to Docker.
 
+# Package: golang-github-containers-libpod-dev
+# Architecture: all
+# Depends: ${misc:Depends},
+#     ,golang-dbus-dev (>= 5.0.2~)
+#     ,golang-ginkgo-dev
+#     ,golang-github-appc-cni-dev (>= 0.8)
+#     ,golang-github-buger-goterm-dev
+#     ,golang-github-checkpoint-restore-go-criu-dev
+#     ,golang-github-containerd-cgroups-dev
+#     ,golang-github-containernetworking-plugins-dev (>= 0.8.7)
+#     ,golang-github-containers-buildah-dev (>= 1.23)
+#     ,golang-github-containers-common-dev (>= 0.44.4)
+#     ,golang-github-containers-image-dev (>= 5.16)
+#     ,golang-github-containers-ocicrypt-dev
+#     ,golang-github-containers-psgo-dev
+#     ,golang-github-containers-storage-dev (>= 1.36)
+#     ,golang-github-coreos-bbolt-dev (>= 1.3.3~)
+#     ,golang-github-coreos-go-iptables-dev (>= 0.4.2~)
+#     ,golang-github-coreos-go-systemd-dev (>= 20~)
+#     ,golang-github-cyphar-filepath-securejoin-dev (>= 0.2.2~)
+#     ,golang-github-docker-distribution-dev (>= 2.7.1~)
+#     ,golang-github-docker-docker-dev (>= 20.10.0~)
+#     ,golang-github-docker-go-connections-dev (>= 0.4.0~)
+#     ,golang-github-docker-go-units-dev (>= 0.4.0~)
+#     ,golang-github-docker-spdystream-dev
+#     ,golang-github-dtylman-scp-dev
+#     ,golang-github-fullsailor-pkcs7-dev
+#     ,golang-github-ghodss-yaml-dev
+#     ,golang-github-google-shlex-dev
+#     ,golang-github-google-uuid-dev
+#     ,golang-github-hashicorp-go-multierror-dev
+#     ,golang-github-influxdata-tail-dev (>= 1.0.0+git20180327.c434825-2~) | golang-github-hpcloud-tail-dev
+#     ,golang-github-json-iterator-go-dev
+#     ,golang-github-mrunalp-fileutils-dev
+#     ,golang-github-opencontainers-go-digest-dev
+#     ,golang-github-opencontainers-image-spec-dev
+#     ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc92~)
+#     ,golang-github-opencontainers-runtime-tools-dev (>= 0.9.0~)
+#     ,golang-github-opencontainers-selinux-dev (>= 1.2.2~)
+#     ,golang-github-openshift-imagebuilder-dev
+#     ,golang-github-pkg-errors-dev
+#     ,golang-github-pkg-profile-dev
+#     ,golang-github-rootless-containers-rootlesskit-dev
+#     ,golang-github-seccomp-libseccomp-golang-dev
+#     ,golang-github-sirupsen-logrus-dev
+#     ,golang-github-stretchr-testify-dev
+#     ,golang-github-uber-go-atomic-dev
+#     ,golang-github-ulikunitz-xz-dev
+#     ,golang-github-vbatts-tar-split-dev
+#     ,golang-github-vishvananda-netlink-dev (>= 1.0.0+git20181030~)
+#     ,golang-github-vividcortex-ewma-dev
+#     ,golang-go-zfs-dev
+#     ,golang-go.opencensus-dev
+#     ,golang-golang-x-crypto-dev
+#     ,golang-golang-x-sys-dev
+#     ,golang-golang-x-text-dev
+#     ,golang-golang-x-xerrors-dev
+#     ,golang-gomega-dev
+#     ,golang-google-genproto-dev
+#     ,golang-google-grpc-dev
+#     ,golang-gopkg-inf.v0-dev
+#     ,golang-gopkg-square-go-jose.v2-dev
+#     ,golang-gopkg-yaml.v3-dev
+#     ,golang-k8s-sigs-structured-merge-diff-dev
+#     ,golang-toml-dev
+# Description: engine to run OCI-based containers in Pods (library)
+#  Podman is an engine for running OCI-based containers in Pods.
+#  Podman provides a CLI interface for managing Pods, Containers, and
+#  Container Images.
+#  .
+#  At a high level, the scope of libpod and podman is the following:
+#   * Support multiple image formats including the OCI and Docker image
+#     formats.
+#   * Support for multiple means to download images including trust & image
+#     verification.
+#   * Container image management (managing image layers, overlay filesystems,
+#     etc).
+#   * Full management of container lifecycle.
+#   * Support for pods to manage groups of containers together.
+#   * Resource isolation of containers and pods.
+#   * Support for a Docker-compatible CLI interface through Podman.
+#  .
+#  Podman is a daemon-less alternative to Docker.
+#  .
+#  This package contains golang sources that other packages may require for
+# building.
+
 Package: podman-docker
 Architecture: any
+Built-Using: ${misc:Built-Using}
 Depends: ${misc:Depends}, ${shlibs:Depends}, podman
 Conflicts: docker.io
 Recommends: docker-compose

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 export DH_GOLANG_GO_GENERATE := 1
 
-export DH_GOLANG_INSTALL_EXTRA := $(wildcard libpod/*/testdata/*)
+export DH_GOLANG_INSTALL_EXTRA := $(wildcard libpod/*/testdata/* libpod/*/cni/*/*/*)
 export DH_GOLANG_EXCLUDES := dependencies test/e2e contrib/perftest test/utils test/endpoint hack/podman-registry-go pkg/bindings/test
 
 export HOME=$(CURDIR)/debian/tmp
@@ -26,6 +26,7 @@
 
 override_dh_auto_configure:
 	# force debhelper to symlink subdirs in docker, enables workarounds below
+	mkdir -v -p _output/src/github.com/docker _output/src/github.com/seccomp
 	mkdir -v -p _output/src/github.com/docker/docker/vendor/github.com/docker/go-connections/
 	dh_auto_configure
 	# workaround some vendoring issues - in ubuntu all docker vendored libraries
@@ -33,6 +34,9 @@
 	test -d _output/src/github.com/docker/libnetwork || \
 	  ln -sv docker/vendor/github.com/docker/libnetwork \
 	     _output/src/github.com/docker
+	test -d _output/src/github.com/seccomp/libseccomp-golang || \
+	  ln -sv ../docker/docker/vendor/github.com/seccomp/libseccomp-golang \
+	  _output/src/github.com/seccomp
 
 	# Golang insanity
 	# workaround "sub-vendored" package github.com/docker/go-connections/nat
@@ -60,7 +64,7 @@
 	  XDG_DATA_HOME=$(CURDIR)/debian/tmp-home/.local/share \
 	  XDG_RUNTIME_DIR=$(CURDIR)/debian/tmp-home/run \
 	  PATH="$(CURDIR)/_output/bin:$$PATH" \
-	  DH_GOLANG_EXCLUDES="$${DH_GOLANG_EXCLUDES} libpod/lock/file libpod/hack/podman-registry-go libpod/pkg/bindings/test podman/cmd/podman/common" \
+	  DH_GOLANG_EXCLUDES="$${DH_GOLANG_EXCLUDES} libpod/network/cni libpod/lock/file libpod/hack/podman-registry-go libpod/pkg/bindings/test podman/cmd/podman/common" \
 	dh_auto_test -v --max-parallel=2 -- -tags "$(BUILDTAGS)"
 	rm -rf $(CURDIR)/debian/tmp-home
 endif
@@ -76,3 +80,4 @@
 override_dh_installsystemd:
 	dh_installsystemd
 	dh_installsystemd --name=podman-auto-update
+	dh_installsystemd --name=podman-restart

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+ds1,\
repack,compression=xz,\
dirversionmangle=s/-rc/~rc/,\
uversionmangle=s/-rc/~rc/,\
dversionmangle=s{[+~]ds\d*}{},\
" https://github.com/containers/podman/releases \
  .*/archive/refs/tags/v?(\d[-\w\d\.]+)\.tar\.gz
